'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

const index = require('./index-15d2a36c.js');

const k2btEditCollectionCss = ":host{display:block}.K2BT_EditCollectionItemDelete::after{cursor:pointer}";

const K2btEditCollection = class {
  constructor(hostRef) {
    index.registerInstance(this, hostRef);
    this.inputEvent = index.createEvent(this, "input", 7);
    this.changeEvent = index.createEvent(this, "change", 7);
    this.value = [];
    this.maxSelectionSize = 0;
    this.datatype = K2btEditCollection.DATATYPE_CHARACTER;
    // used only for character
    this.length = 10;
    // used only for numerics
    this.integers = 5;
    // used only for numerics
    this.decimals = 2;
    this.enabled = true;
    this.inputclass = '';
    this.readonlyclass = '';
    this.invitemessage = '';
    this.itemInputs = [];
    this._triggerChangeDebouncer = null;
  }
  removeItem(index) {
    this.value = this.value.filter((_item, i) => i != index);
    this.triggerChangeEvent();
  }
  onInput(index, _ev) {
    if (index == this.value.length && this.itemInputs[index].value !== '') {
      this.value = this.value.concat(['']);
    }
    this.value[index] = this.itemInputs[index].value;
    _ev.stopPropagation();
    this.inputEvent.emit(null);
  }
  triggerChangeEvent() {
    if (this._triggerChangeDebouncer != null)
      clearTimeout(this._triggerChangeDebouncer);
    this._triggerChangeDebouncer = setTimeout(() => {
      this.changeEvent.emit(null);
    }, 200);
  }
  render() {
    this.itemInputs = [];
    var styleObj = {};
    var maxLength = 0;
    if (this.datatype == K2btEditCollection.DATATYPE_NUMERIC) {
      //@ts-ignore
      styleObj.textAlign = 'right';
      maxLength = this.integers + this.decimals + (this.decimals > 0 ? 1 : 0);
    }
    else {
      maxLength = this.length;
    }
    //@ts-ignore
    styleObj.width = maxLength + 'ch';
    const displayedvalues = this.maxSelectionSize == 0 || this.value.length < this.maxSelectionSize ? this.value.concat(['']) : this.value;
    return (index.h(index.Host, null, index.h("div", { class: "K2BT_EditCollection", style: !this.enabled ? {} : { display: 'none' } }, !this.enabled
      ? this.value.map(v => (index.h("div", { class: "K2BT_EditCollectionItem" }, index.h("p", { class: "form-control-static" }, index.h("span", { class: !this.enabled ? this.readonlyclass : this.readonlyclass + ' gx-invisible', "data-gx-readonly": "" }, v)))))
      : ''), index.h("div", { class: "K2BT_EditCollection", style: this.enabled ? {} : { display: 'none' } }, displayedvalues.map((v, index$1) => (index.h("div", { class: "K2BT_EditCollectionItem" }, index.h("input", { class: 'form-control K2BT_EditCollectionItemInput ' + this.inputclass, type: "text", value: v, style: styleObj, maxLength: maxLength, onInput: ev => this.onInput(index$1, ev), ref: c => (this.itemInputs[index$1] = c), onChange: () => this.triggerChangeEvent(), placeholder: this.invitemessage }), index.h("span", { class: "K2BT_EditCollectionItemDelete", onClick: () => this.removeItem(index$1) })))))));
  }
};
K2btEditCollection.DATATYPE_CHARACTER = 'CHAR';
K2btEditCollection.DATATYPE_NUMERIC = 'NUMERIC';
K2btEditCollection.style = k2btEditCollectionCss;

exports.k2bt_edit_collection = K2btEditCollection;
