'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

const index = require('./index-15d2a36c.js');
const utils = require('./utils-aa13c8b6.js');

const k2btEnhancedcomboCss = ":host{display:block}k2bt-enhancedcombo:focus-visible{outline:none}.K2BTEnhancedComboContentsOpen{display:flex;flex-direction:column;position:absolute}.K2BTEnhancedComboItems{max-height:300px;overflow:auto;scrollbar-width:thin;scrollbar-color:#d7d7d7 transparent}.K2BTEnhancedComboItems::-webkit-scrollbar{width:6px}.K2BTEnhancedComboItems::-webkit-scrollbar-thumb{background-color:#d7d7d7;border:1px solid transparent;cursor:pointer}.K2BTEnhancedComboContentsClosed{display:none}.K2BTEnhancedComboItem{display:flex;flex-direction:row;align-items:center}.K2BTEnhancedComboItem:hover{cursor:pointer}.K2BTEnhancedComboItem_TextContainer{display:flex;flex-grow:1}.K2BTEnhancedComboSubtitle{font-size:12px}.K2BTEnhancedComboIcon{width:30px;height:30px;object-fit:cover;margin-right:4px}.K2BTEnhancedComboIconInvisible{visibility:hidden}.K2BTEnhancedComboNoItemsFound{width:100%;text-align:center;margin-top:40px;margin-bottom:40px}.K2BTEnhancedComboTrailingText{flex-grow:0}.K2BT_EnhancedComboCheckbox{margin-right:8px;margin-top:6px;pointer-events:none}.K2BTEnhancedComboDisabled{cursor:normal;opacity:0.8}";

const K2btEnhancedcombo = class {
  constructor(hostRef) {
    index.registerInstance(this, hostRef);
    this.selectionErrorEvent = index.createEvent(this, "selectionError", 7);
    this.focusEvent = index.createEvent(this, "focus", 7);
    this.inputEvent = index.createEvent(this, "input", 7);
    this.changeEvent = index.createEvent(this, "change", 7);
    this.searchChangedEvent = index.createEvent(this, "searchChanged", 7);
    this.newRecordClickedEvent = index.createEvent(this, "newRecordClicked", 7);
    this.value = null;
    this.includesearch = true;
    this.includeemptyitem = true;
    this.emptyitemvalue = '';
    this.emptyitemtext = '(none)';
    this.noresultsfoundtext = 'No results found';
    this.enableadditem = true;
    this.additemcaption = 'New record';
    this.clearselectioncaption = 'Clear selection';
    this.selectallcaption = 'Clear selection';
    this.searchfieldplaceholder = 'Search';
    this.searchvalue = '';
    this.enabled = true;
    this.maxSelectionSize = 1;
    this.headermaxvisibleitems = 3;
    this.readonlyclass = '';
    this.showselectionastags = false;
    this.showiconsintags = true;
    this.displayaslist = false;
    this.enableclearselectionaction = false;
    this.enableselectallaction = false;
    this.activeElementValue = null;
    this.showemptyiteminlist = true;
    this.optionswidth = null;
    this.container = null;
    this.selectedElement = null;
    this.searchfield = null;
    this.listContainer = null;
    this._keyboardSearchPrefix = '';
    this._keyboardSearchLastKeystroke = null;
  }
  isCollection() {
    return this.maxSelectionSize != 1;
  }
  processKeydown(event) {
    if (event.key == 'Escape') {
      this.resetPrefixSearch();
      this.open = false;
      event.stopPropagation();
    }
    else if (event.key == 'Enter') {
      this.resetPrefixSearch();
      this.open = !this.open;
      event.stopPropagation();
    }
    else if (this.isCollection()) {
      this.processKeydownForCollection(event);
    }
    else {
      this.processKeydownSingleSelection(event);
    }
  }
  processKeydownForCollection(event) {
    var pos;
    if (this.open) {
      if (event.key == 'ArrowDown') {
        this.processArrowDownForCollection(event, pos);
      }
      else if (event.key == 'ArrowUp') {
        this.processArrowUpForCollection(event, pos);
      }
      else if (event.key === ' ' || event.key === 'Spacebar') {
        this.processSpacebarForCollection(event);
      }
      else {
        this.processCharacterForCollection(event);
      }
    }
  }
  processCharacterForCollection(event) {
    var key = event.key;
    // Check if the key pressed maps to a single character
    if (key.length == 1) {
      if (document.activeElement != this.searchfield) {
        var currentDate = Date.now();
        if (this._keyboardSearchLastKeystroke == null || currentDate - this._keyboardSearchLastKeystroke > 3000) {
          this._keyboardSearchPrefix = '';
        }
        this._keyboardSearchPrefix = this._keyboardSearchPrefix + key;
        var currentValues = utils.ControlInfoValue.getAtomicValues_impl(this.getFilteredValues());
        var selectedValue = currentValues.find(v => v.description.toLowerCase().indexOf(this._keyboardSearchPrefix.toLowerCase()) == 0);
        if (selectedValue != null) {
          this.activeElementValue = selectedValue.value.trim();
        }
        this._keyboardSearchLastKeystroke = currentDate;
      }
    }
  }
  processSpacebarForCollection(event) {
    var _a;
    if (((_a = this.activeElementValue) !== null && _a !== void 0 ? _a : '') !== '') {
      this.setValueWithoutClosing(this.activeElementValue, false);
      event.stopPropagation();
      event.preventDefault();
    }
  }
  processArrowUpForCollection(event, pos) {
    this.resetPrefixSearch();
    event.stopPropagation();
    event.preventDefault();
    //up key
    var currentValues = utils.ControlInfoValue.getAtomicValues_impl(this.getFilteredValues());
    if (currentValues.length > 0) {
      pos = currentValues.findIndex(v => v.value.trim() == this.activeElementValue);
      if (pos == -1) {
        pos = currentValues.length - 1;
      }
      else {
        pos = (((pos - 1) % currentValues.length) + currentValues.length) % currentValues.length;
      }
      this.activeElementValue = currentValues[pos].value.trim();
    }
  }
  processArrowDownForCollection(event, pos) {
    this.resetPrefixSearch();
    event.stopPropagation();
    event.preventDefault();
    //down key
    var currentValues = utils.ControlInfoValue.getAtomicValues_impl(this.getFilteredValues());
    if (currentValues.length > 0) {
      pos = currentValues.findIndex(v => v.value.trim() == this.activeElementValue);
      if (pos == -1) {
        pos = 0;
      }
      else {
        pos = (((pos + 1) % currentValues.length) + currentValues.length) % currentValues.length;
      }
      this.activeElementValue = currentValues[pos].value.trim();
    }
  }
  processKeydownSingleSelection(event) {
    if (event.key == 'ArrowDown') {
      this.processArrowDownForSingleSelection(event);
    }
    else if (event.key == 'ArrowUp') {
      this.processArrowUpForSingleSelection(event);
    }
    else {
      this.processCharacterForSingleSelection(event);
    }
  }
  processCharacterForSingleSelection(event) {
    var key = event.key;
    // Check if the key pressed maps to a single character
    if (key.length == 1) {
      if (document.activeElement != this.searchfield) {
        var currentDate = Date.now();
        if (this._keyboardSearchLastKeystroke == null || currentDate - this._keyboardSearchLastKeystroke > 3000) {
          this._keyboardSearchPrefix = '';
        }
        this._keyboardSearchPrefix = this._keyboardSearchPrefix + key;
        var currentValues = utils.ControlInfoValue.getAtomicValues_impl(this.getFilteredValues());
        var selectedValue = currentValues.find(v => v.description.toLowerCase().indexOf(this._keyboardSearchPrefix.toLowerCase()) == 0);
        if (selectedValue != null) {
          this.setValueWithoutClosing(selectedValue.value.trim(), false);
        }
        this._keyboardSearchLastKeystroke = currentDate;
      }
    }
  }
  processArrowUpForSingleSelection(event) {
    this.resetPrefixSearch();
    event.stopPropagation();
    event.preventDefault();
    //up key
    var currentValues = utils.ControlInfoValue.getAtomicValues_impl(this.getFilteredValues());
    if (currentValues.length > 0) {
      var pos = currentValues.findIndex(v => v.value.trim() == this.value[0].trim());
      if (pos == -1) {
        this.setValueWithoutClosing(currentValues[currentValues.length - 1].value.trim(), false);
      }
      else {
        pos = (((pos - 1) % currentValues.length) + currentValues.length) % currentValues.length;
        this.setValueWithoutClosing(currentValues[pos].value.trim(), false);
      }
    }
  }
  processArrowDownForSingleSelection(event) {
    this.resetPrefixSearch();
    event.stopPropagation();
    event.preventDefault();
    //down key
    var currentValues = utils.ControlInfoValue.getAtomicValues_impl(this.getFilteredValues());
    if (currentValues.length > 0) {
      var pos = currentValues.findIndex(v => v.value.trim() == this.value[0].trim());
      if (pos == -1) {
        this.setValueWithoutClosing(currentValues[0].value.trim(), false);
      }
      else {
        pos = (((pos + 1) % currentValues.length) + currentValues.length) % currentValues.length;
        this.setValueWithoutClosing(currentValues[pos].value.trim(), false);
      }
    }
  }
  onFocusIn() {
    this.resetPrefixSearch();
    this.focusEvent.emit();
  }
  resetPrefixSearch() {
    this._keyboardSearchLastKeystroke = null;
  }
  closeMenu(ev) {
    this.resetPrefixSearch();
    if (this.open && this.container && !this.container.contains(ev.target))
      this.open = false;
  }
  getHeaderContent() {
    if (this.value == null)
      return this.emptyitemtext;
    else {
      var vals = this.getAtomicValues().filter(value => this.valueIsSelected(value));
      if (vals.length > 0) {
        if (this.isCollection() && this.showselectionastags) {
          return this.getHeaderTagsContent(vals);
        }
        else {
          if (vals.length > this.headermaxvisibleitems)
            return [
              vals
                .slice(0, this.headermaxvisibleitems)
                .map(v => this.getSelectedItemSpan(v))
                .reduce((prev, curr) => [prev, index.h("span", null, ",\u00A0"), curr]),
              index.h("span", null, "\u00A0(+", vals.length - this.headermaxvisibleitems, ")"),
            ];
          else
            return vals.map(v => this.getSelectedItemSpan(v)).reduce((prev, curr) => [prev, index.h("span", null, ",\u00A0"), curr]);
        }
      }
      else
        return this.emptyitemtext;
    }
  }
  getSelectedItemSpan(v) {
    return index.h("span", { class: "K2BT_EnhancedControlInfoSelectedValue" }, v.description);
  }
  getReadonlyContent() {
    if (this.value == null)
      return this.emptyitemtext;
    else {
      var vals = this.getAtomicValues().filter(value => this.valueIsSelected(value));
      if (vals.length > 0)
        return vals.map(v => v.description).join(', ');
      else
        return this.emptyitemtext;
    }
  }
  getHeaderTagsContent(vals) {
    var containsIcons = utils.ControlInfoValue.containsIcons(this.getAtomicValues());
    return vals.map(v => {
      return (index.h("div", { class: "K2BT_EnhancedComboHeaderTag" }, this.showiconsintags && containsIcons && v.imageUrl !== '' ? index.h("img", { class: "K2BT_EnhancedComboTagIcon", src: v.imageUrl }) : '', index.h("span", { class: "K2BT_EnhancedComboHeaderTagDescription" }, v.description), index.h("span", { class: "K2BT_EnhancedComboHeaderTagDelete", onClick: ev => {
          ev.cancelBubble = true;
          this.setValueWithoutClosing(v.value, false);
        } })));
    });
  }
  valueIsSelected(value) {
    return this.value.filter(v => value.value.trim() == v.toString().trim()).length > 0;
  }
  toggleContentVisibilty() {
    this.resetPrefixSearch();
    this.open = !this.open;
  }
  getRawValues() {
    var result;
    if (this.values == null) {
      result = [];
    }
    else if (typeof this.values === 'string') {
      if (this.values == '')
        result = [];
      else
        result = JSON.parse(this.values);
    }
    else {
      result = [...this.values];
    }
    if (this.includeemptyitem && !this.isCollection()) {
      result.unshift({
        value: '',
        description: this.emptyitemtext,
        imageUrl: '',
        detail: '',
        trailingText: '',
        badgeClass: '',
        items: [],
        tooltip: ''
      });
    }
    return result;
  }
  getFilteredValues() {
    var result = this.getRawValues();
    if (this.includesearch && this.searchvalue != '')
      result = this.getFilteredValues_impl(result);
    return result;
  }
  getFilteredValues_impl(origin) {
    var result = [];
    if (origin != undefined) {
      for (let cv of origin) {
        if (cv.description.toLocaleLowerCase().indexOf(this.searchvalue.toLocaleLowerCase()) != -1 ||
          cv.detail.toLocaleLowerCase().indexOf(this.searchvalue.toLocaleLowerCase()) != -1 ||
          cv.trailingText.toLocaleLowerCase().indexOf(this.searchvalue.toLocaleLowerCase()) != -1) {
          result = result.concat(cv);
        }
        else {
          // Check if child items must be added
          var filteredChildren = this.getFilteredValues_impl(cv.items);
          if (filteredChildren.length > 0) {
            var cv2 = Object.assign({}, cv);
            cv2.items = filteredChildren;
            result = result.concat(cv2);
          }
        }
      }
    }
    return result;
  }
  setValue(value) {
    this.setValueWithoutClosing(value, true);
    this.open = false;
  }
  setValueWithoutClosing(value, triggerChangeEventImmediately) {
    if (this.isCollection()) {
      if (this.value.filter(v => v.toString().trim() === value.toString().trim()).length === 0) {
        if (!this.selectionIsFull())
          this.value = this.value.concat([value]);
        else {
          this.errorCode = K2btEnhancedcombo.ERROR_SELECTION_FULL;
          this.selectionErrorEvent.emit({});
        }
      }
      else
        this.value = this.value.filter(v => v.toString().trim() !== value.toString().trim());
    }
    else {
      this.value = [value];
    }
    if (this.setValueDebouncer) {
      clearTimeout(this.setValueDebouncer);
      this.setValueDebouncer = null;
    }
    if (triggerChangeEventImmediately) {
      this.emitChangedEvents(value);
    }
    else {
      this.setValueDebouncer = setTimeout((() => {
        this.setValueDebouncer = null;
        this.emitChangedEvents(value);
      }).bind(this), 200);
    }
  }
  emitChangedEvents(value) {
    this.inputEvent.emit();
    this.changeEvent.emit(value);
  }
  changeSearchValue(value) {
    this.searchvalue = value;
    this.searchChangedEvent.emit({ value });
  }
  onIncludeNewRecordClick() {
    this.open = false;
    this.newRecordClickedEvent.emit(null);
  }
  render() {
    var style = {};
    if (this.optionswidth != null) {
      //@ts-ignore
      style.width = this.optionswidth;
      //@ts-ignore
      style.minWidth = 'initial';
    }
    this.selectedElement = null;
    var listClass = '';
    if (!this.displayaslist)
      listClass = this.open ? 'K2BTEnhancedComboContentsOpen' : 'K2BTEnhancedComboContentsClosed';
    else
      listClass = 'K2BTEnhancedListContents';
    return (index.h("div", null, index.h("p", { class: "form-control-static", style: this.enabled ? { display: 'none' } : {} }, index.h("span", { class: !this.enabled ? this.readonlyclass : this.readonlyclass + ' gx-invisible', "data-gx-readonly": "" }, this.getReadonlyContent())), index.h("div", { tabindex: "0", class: "K2BTEnhancedCombo", ref: node => (this.container = node), style: !this.enabled ? { display: 'none' } : {} }, this.addHeaderIfNecessary(), index.h("div", { class: listClass, style: style, ref: c => (this.listContainer = c) }, this.includesearch ? (index.h("input", { type: "text", class: "form-control K2BTEnhancedComboSearchInput", ref: c => (this.searchfield = c), onInput: event => {
        this.changeSearchValue(event.target.value);
        event.stopPropagation();
      }, onChange: event => event.stopPropagation(), placeholder: this.searchfieldplaceholder })) : (''), this.getCollectionActionsHeader(), index.h("div", { class: "K2BTEnhancedComboItems" }, this.getComboContent()), this.enableadditem ? (index.h("span", { class: "K2BTEnhancedComboNewAction", onClick: () => this.onIncludeNewRecordClick() }, this.additemcaption)) : ('')))));
  }
  getCollectionActionsHeader() {
    return this.enableselectallaction || this.enableclearselectionaction ? (index.h("div", { class: "K2BT_EnhancedComboCollectionActions" }, this.getClearSelectionAction(), this.getSelectAllAction())) : ('');
  }
  getSelectAllAction() {
    return this.enableselectallaction ? (index.h("span", { class: "K2BT_EnhancedComboSelectAll", onClick: () => this.onSelectAllClick() }, this.selectallcaption)) : ('');
  }
  getClearSelectionAction() {
    return this.enableclearselectionaction ? (index.h("span", { class: "K2BT_EnhancedComboSelectNone", onClick: () => this.onClearSelectionClick() }, this.clearselectioncaption)) : ('');
  }
  onClearSelectionClick() {
    this.value = [];
    this.emitChangedEvents(this.value);
  }
  onSelectAllClick() {
    this.value = this.getAtomicValues().map(v => v.value);
    this.emitChangedEvents(this.value);
  }
  addHeaderIfNecessary() {
    return !this.displayaslist ? (index.h("div", { class: "K2BTEnhancedComboHeader", onClick: () => this.toggleContentVisibilty() }, index.h("div", { class: "K2BTHeaderContent" }, this.getHeaderContent()))) : ('');
  }
  getAtomicValues() {
    return utils.ControlInfoValue.getAtomicValues_impl(this.getRawValues());
  }
  getComboContent() {
    const rawValues = utils.ControlInfoValue.getAtomicValues_impl(this.getRawValues());
    var containsDetails = utils.ControlInfoValue.containsDetails(rawValues);
    var containsIcons = utils.ControlInfoValue.containsIcons(rawValues);
    var containsTrailingText = utils.ControlInfoValue.containsTrailingText(rawValues);
    var containsBadges = utils.ControlInfoValue.containsBadges(rawValues);
    var containsTooltip = utils.ControlInfoValue.containsTooltip(rawValues);
    const filteredValues = !this.open && !this.displayaslist ? [] : this.getFilteredValues();
    if (filteredValues.length > 0)
      return filteredValues.map(item => this.getItemContent(item, containsDetails, containsIcons, containsTrailingText, containsBadges, containsTooltip));
    else
      return index.h("div", { class: "K2BTEnhancedComboNoItemsFound" }, this.noresultsfoundtext);
  }
  onImageError(e) {
    e.target.classList.add('K2BTEnhancedComboIconInvisible');
  }
  getItemContent(item, containsDetails, containsIcons, containsTrailingText, containsBadges, containsTooltip) {
    var _a;
    if (((_a = item.items) === null || _a === void 0 ? void 0 : _a.length) > 0) {
      return this.getCategoryContent(item, containsDetails, containsIcons, containsTrailingText, containsBadges, containsTooltip);
    }
    else {
      return this.getAtomicItemContent(item, containsIcons, containsTrailingText, containsDetails, containsBadges, containsTooltip);
    }
  }
  getAtomicItemContent(item, containsIcons, containsTrailingText, containsDetails, containsBadges, containsTooltip) {
    var itemClass = 'K2BTEnhancedComboItem';
    if (this.valueIsSelected(item))
      itemClass += ' K2BTEnhancedComboSelected';
    else if (this.selectionIsFull())
      itemClass += ' K2BTEnhancedComboDisabled';
    if (this.activeElementValue === item.value)
      itemClass += ' K2BTEnhancedComboActive';
    var style = item.value === '' && !this.showemptyiteminlist ? { display: 'none' } : {};
    return (index.h("div", { class: itemClass, style: style, ref: c => {
        if ((!this.isCollection() && this.valueIsSelected(item)) || (this.isCollection() && this.activeElementValue === item.value))
          this.selectedElement = c;
      }, onClick: () => {
        if (this.isCollection())
          this.setValueWithoutClosing(item.value.trim(), true);
        else
          this.setValue(item.value.trim());
      } }, this.addCheckboxIfNecessary(item), this.addIconIfNecessary(containsIcons, item), this.addBadgeIfNecessary(containsBadges, item), this.addMainItemContent(item, containsTrailingText, containsDetails), this.addTooltipIfNecessary(item, containsTooltip)));
  }
  addTooltipIfNecessary(item, containsTooltip) {
    if (!containsTooltip)
      return '';
    //The html bellow tend to the final html in the final solution of fields with tooltips using K2BTools.
    //else return <div class="K2BTEnhancedCombo_TooltipContainer">   <div class="K2BTEnhancedComboTooltipImage"/> <span class="K2BTEnhancedCombo_Tooltip">{item.tooltip}</span></div>
    //This is a temporal solution to complete faster a customer request.
    else
      return index.h("div", { class: "K2BImage_ContextHelp GX_Image_K2BContextHelp_Class", title: item.tooltip });
  }
  addMainItemContent(item, containsTrailingText, containsDetails) {
    return (index.h("div", { class: "K2BTEnhancedComboItem_TextColumn" }, index.h("div", { class: "K2BTEnhancedComboItem_TextContainer" }, index.h("span", { class: "K2BTEnhancedComboDescription" }, this.getHighlightedText(item.description)), containsTrailingText ? index.h("span", { class: "K2BTEnhancedComboTrailingText" }, this.getHighlightedText(item.trailingText)) : ''), index.h("div", { class: "K2BTEnhancedComboItem_TextContainer" }, containsDetails ? index.h("span", { class: "K2BTEnhancedComboSubtitle" }, this.getHighlightedText(item.detail)) : '')));
  }
  addBadgeIfNecessary(containsBadges, item) {
    const c = 'K2BTEnhancedComboBadge ' + item.badgeClass;
    if (!containsBadges)
      return '';
    else
      return index.h("div", { class: c });
  }
  addIconIfNecessary(containsIcons, item) {
    if (!containsIcons)
      return '';
    else
      return (index.h("div", { class: "K2BTEnhancedComboIconContainer" }, index.h("img", { class: item.imageUrl === '' ? 'K2BTEnhancedComboIcon K2BTEnhancedComboIconInvisible' : 'K2BTEnhancedComboIcon', src: item.imageUrl, onError: e => this.onImageError(e) })));
  }
  addCheckboxIfNecessary(item) {
    return this.isCollection() ? (index.h("div", { class: "K2BT_EnhancedComboCheckbox" }, index.h("input", { type: "checkbox", checked: this.valueIsSelected(item), tabIndex: -1, disabled: this.selectionIsFull() && !this.valueIsSelected(item) }), index.h("label", { htmlFor: "", "data-gx-sr-only": "" }, "\u00A0"))) : ('');
  }
  getCategoryContent(item, containsDetails, containsIcons, containsTrailingText, containsBadges, containsTooltip) {
    return (index.h("div", { class: "K2BTEnhancedComboCategory" }, index.h("span", { class: "K2BTEnhancedComboCategoryName" }, item.description), index.h("div", { class: "K2BTEnchancedComboCategoryContents" }, item.items.map(i => this.getItemContent(i, containsDetails, containsIcons, containsTrailingText, containsBadges, containsTooltip)))));
  }
  selectionIsFull() {
    return this.isCollection() && this.maxSelectionSize != 0 && this.maxSelectionSize <= this.value.length;
  }
  getHighlightedText(originalText) {
    var position = originalText.toLowerCase().indexOf(this.searchvalue.toLowerCase());
    if (this.searchvalue == undefined || this.searchvalue == '' || position == -1) {
      return index.h("span", null, originalText);
    }
    else {
      return (index.h("span", null, originalText.substring(0, position), index.h("span", { class: "K2BTEnhancedComboSearchHighlight" }, originalText.substring(position, position + this.searchvalue.length)), this.getHighlightedText(originalText.substring(position + this.searchvalue.length))));
    }
  }
  componentDidRender() {
    if (this.selectedElement != null) {
      this.selectedElement.scrollIntoView({ block: 'nearest' });
    }
    if (this.listContainer.getBoundingClientRect().right + this.listContainer.getBoundingClientRect().width > window.innerWidth) {
      this.listContainer.style.right = '0px';
    }
    else {
      this.listContainer.style.right = null;
    }
  }
  componentDidLoad() {
    var currentValues = this.getAtomicValues();
    if (!this.isCollection() && !this.includeemptyitem && currentValues.filter(v => this.valueIsSelected(v)).length == 0) {
      if (currentValues.length > 0) {
        this.setValueWithoutClosing(currentValues[0].value.trim(), true);
      }
    }
  }
};
K2btEnhancedcombo.ERROR_SELECTION_FULL = 'SELECTION_FULL';
K2btEnhancedcombo.style = k2btEnhancedcomboCss;

const k2btEnhancedsuggestCss = ":host{display:block}k2bt-enhancedsuggest:focus-visible{outline:none}.K2BTEnhancedComboContentsOpen{display:flex;flex-direction:column;position:absolute}.K2BTEnhancedComboItems{max-height:300px;overflow:auto;scrollbar-width:thin;scrollbar-color:#d7d7d7 transparent}.K2BTEnhancedComboItems::-webkit-scrollbar{width:6px}.K2BTEnhancedComboItems::-webkit-scrollbar-thumb{background-color:#d7d7d7;border:1px solid transparent;cursor:pointer}.K2BTEnhancedComboContentsClosed{display:none}.K2BTEnhancedComboItem{display:flex;flex-direction:row;align-items:center}.K2BTEnhancedComboItem:hover{cursor:pointer}.K2BTEnhancedComboItem_TextContainer{display:flex;flex-grow:1}.K2BTEnhancedComboSubtitle{font-size:12px}.K2BTEnhancedComboIcon{width:30px;height:30px;object-fit:cover;margin-right:4px}.K2BTEnhancedComboIconInvisible{visibility:hidden}.K2BTEnhancedComboNoItemsFound{width:100%;text-align:center;margin-top:40px;margin-bottom:40px}.K2BTEnhancedComboTrailingText{flex-grow:0}@keyframes spinner{to{transform:rotate(360deg)}}.K2BT_LoadingSpinner{-webkit-box-sizing:border-box;box-sizing:border-box;position:relative;left:50%;width:20px;height:19px;margin-top:10px;margin-bottom:10px;border-radius:50%;border:2px solid #ccc;border-top-color:#000;-webkit-animation:spinner 0.6s linear infinite;animation:spinner 0.6s linear infinite;margin-left:-10px}.K2BT_EnhancedComboCheckbox{margin-right:8px;margin-top:6px;pointer-events:none}.K2BTEnhancedComboDisabled{cursor:normal;opacity:0.8}.K2BTEnhancedSuggestTags{display:flex;flex-direction:row;flex-wrap:wrap}";

const K2btEnhancedsuggest = class {
  constructor(hostRef) {
    index.registerInstance(this, hostRef);
    this.selectionErrorEvent = index.createEvent(this, "selectionError", 7);
    this.focusEvent = index.createEvent(this, "focus", 7);
    this.suggestValueChanged = index.createEvent(this, "suggestValueChanged", 7);
    this.newRecordClickedEvent = index.createEvent(this, "newRecordClicked", 7);
    this.inputValueChangedEvent = index.createEvent(this, "inputValueChanged", 7);
    this.value = [];
    this.noresultsfoundtext = 'No results found';
    this.enableadditem = true;
    this.additemcaption = 'New record';
    this.enabled = true;
    this.readonlyclass = '';
    this.searchvalue = '';
    this.placeholder = '';
    this.selectedValueDescription = '';
    this.maxSelectionSize = 1;
    this.suggestmaxitems = 5;
    this.activeElementValue = null;
    this.showiconsintags = true;
    this.emptyitemtext = '(none)';
    this.clientSideFiltering = K2btEnhancedsuggest.FILTERING_ENABLED;
    this.inputSize = 0;
    this.container = null;
    this.selectedElement = null;
    this.searchfield = null;
    // See problem with transactions in display mode in 0022649: Soportar datasource dataprovider en extended suggest
    this.seekSuggestValuesForMissingValueExecuted = false;
    this.seekSuggestValuesDebouncer = null;
  }
  isCollection() {
    return this.maxSelectionSize != 1;
  }
  // @ts-ignore
  selectionIsFull() {
    return this.isCollection() && this.maxSelectionSize != 0 && this.maxSelectionSize <= this.value.length;
  }
  itemIsSelected(item) {
    var _a, _b;
    return ((_b = (_a = this.value) === null || _a === void 0 ? void 0 : _a.filter(selectedItem => selectedItem.toString().trim() == item.value.toString().trim()).length) !== null && _b !== void 0 ? _b : 0) > 0;
  }
  async setFocusToSearch() {
    if (this.searchfield != null)
      this.searchfield.focus();
  }
  async updateDescription() {
    if (!this.isCollection()) {
      const atomicValues = this.getAtomicValues();
      const selectedItems = atomicValues.filter(value => this.itemIsSelected(value));
      const selectedItemCount = selectedItems.length;
      if (selectedItemCount > 0) {
        this.searchvalue = this.getValueDescription();
        this.seekSuggestValuesForMissingValueExecuted = false;
      }
      else {
        if (!this.seekSuggestValuesForMissingValueExecuted) {
          this.inputValueChangedEvent.emit(null);
          this.seekSuggestValuesForMissingValueExecuted = true;
        }
        this.searchvalue = '';
      }
    }
  }
  processInput(event) {
    if (event.target == this.searchfield) {
      this.changeSearchValue(this.searchfield.value);
    }
    event.stopPropagation();
    return false;
  }
  processKeydown(event) {
    if (event.key === 'Escape') {
      this.open = false;
      event.stopPropagation();
    }
    if (event.key === 'Tab')
      this.open = false;
    if (!this.isCollection()) {
      this.processKeydownSingleSelection(event);
    }
    else {
      this.processKeydownCollection(event);
    }
  }
  processKeydownCollection(event) {
    if (event.key == 'Enter') {
      this.processEnterKeyWhenCollection(event);
    }
    else if (this.open) {
      if (event.key == 'ArrowDown') {
        this.processArrowDownKeyWhenCollection(event);
      }
      else if (event.key == 'ArrowUp') {
        this.processArrowUpKeyWhenCollection(event);
      }
      else if (event.key === ' ' || event.key === 'Spacebar') {
        this.processSpacebarKeyWhenCollection(event);
      }
    }
  }
  processEnterKeyWhenCollection(event) {
    if (this.open) {
      this.setValueWithoutClosing(this.activeElementValue);
      this.emitChangedEvent();
    }
    this.open = !this.open;
    event.stopPropagation();
  }
  processSpacebarKeyWhenCollection(event) {
    if (this.activeElementValue !== '' && this.activeElementValue !== null) {
      this.setValueWithoutClosing(this.activeElementValue);
      this.emitChangedEvent();
      event.stopPropagation();
      event.preventDefault();
    }
  }
  processArrowUpKeyWhenCollection(event) {
    event.stopPropagation();
    event.preventDefault();
    var currentValues = utils.ControlInfoValue.getAtomicValues_impl(this.getFilteredValues());
    if (currentValues.length > 0) {
      var pos = currentValues.findIndex(v => v.value == this.activeElementValue);
      if (pos == -1) {
        pos = currentValues.length - 1;
      }
      else {
        if (pos === 0)
          pos = -1;
        else
          pos -= 1;
      }
      if (pos !== -1)
        this.activeElementValue = currentValues[pos].value;
      else
        this.activeElementValue = null;
    }
  }
  processArrowDownKeyWhenCollection(event) {
    event.stopPropagation();
    event.preventDefault();
    var currentValues = utils.ControlInfoValue.getAtomicValues_impl(this.getFilteredValues());
    if (currentValues.length > 0) {
      var pos = currentValues.findIndex(v => v.value == this.activeElementValue);
      if (pos === -1) {
        pos = 0;
      }
      else {
        pos = (((pos + 1) % currentValues.length) + currentValues.length) % currentValues.length;
        if (pos === 0)
          pos = -1;
      }
      if (pos !== -1)
        this.activeElementValue = currentValues[pos].value;
      else
        this.activeElementValue = null;
    }
  }
  processKeydownSingleSelection(event) {
    if (event.key == 'Enter') {
      this.processEnterKeyWhenNotCollection(event);
    }
    else if (event.key == 'Tab') {
      this.processTabKeyWhenNotCollection(event);
    }
    else if (this.open) {
      if (event.key == 'ArrowDown') {
        this.processArrowDownKeyWhenNotCollection(event);
      }
      else if (event.key == 'ArrowUp') {
        this.processArrowUpKeyWhenNotCollection(event);
      }
    }
  }
  processArrowUpKeyWhenNotCollection(event) {
    event.stopPropagation();
    event.preventDefault();
    var currentValues = utils.ControlInfoValue.getAtomicValues_impl(this.getFilteredValues());
    if (currentValues.length > 0) {
      var pos = currentValues.findIndex(v => v.value == this.value[0]);
      if (pos == -1) {
        this.setValueWithoutClosing(currentValues[currentValues.length - 1].value);
      }
      else {
        pos = (((pos - 1) % currentValues.length) + currentValues.length) % currentValues.length;
        this.setValueWithoutClosing(currentValues[pos].value);
      }
    }
  }
  processArrowDownKeyWhenNotCollection(event) {
    event.stopPropagation();
    event.preventDefault();
    var currentValues = utils.ControlInfoValue.getAtomicValues_impl(this.getFilteredValues());
    if (currentValues.length > 0) {
      var pos = currentValues.findIndex(v => v.value == this.value[0]);
      if (pos == -1) {
        this.setValueWithoutClosing(currentValues[0].value);
      }
      else {
        pos = (((pos + 1) % currentValues.length) + currentValues.length) % currentValues.length;
        this.setValueWithoutClosing(currentValues[pos].value);
      }
    }
  }
  processEnterKeyWhenNotCollection(event) {
    this.open = !this.open;
    if (!this.open) {
      this.searchvalue = this.getValueDescription();
      this.emitChangedEvent();
    }
    event.stopPropagation();
  }
  processTabKeyWhenNotCollection(event) {
    if (!this.open) {
      if (this.value.length === 0) {
        var availableValues = this.getFilteredValuesWhenClosed();
        if (availableValues.length === 1)
          this.value = [availableValues[0].value];
      }
      this.searchvalue = this.getValueDescription();
      this.emitChangedEvent();
    }
    event.stopPropagation();
  }
  closeMenu(ev) {
    if (this.open && this.container && !this.container.contains(ev.target)) {
      this.open = false;
      if (!this.isCollection())
        this.setValue(this.value[0]);
    }
  }
  async setValue(value) {
    if (!this.isCollection())
      this.open = false;
    this.setValueWithoutClosing(value);
    if (!this.isCollection())
      this.searchvalue = this.getValueDescription();
    this.emitChangedEvent();
  }
  emitChangedEvent() {
    this.suggestValueChanged.emit(this.value);
  }
  setValueWithoutClosing(value) {
    if (!this.isCollection()) {
      if (value !== null && value !== undefined)
        this.value = [value];
      else
        this.value = [];
      this.selectedValueDescription = this.getValueDescription();
    }
    else {
      if (this.value.filter(v => v.toString().trim() === value.toString().trim()).length === 0) {
        if (!this.selectionIsFull())
          this.value = this.value.concat([value]);
        else {
          this.errorCode = K2btEnhancedsuggest.ERROR_SELECTION_FULL;
          this.selectionErrorEvent.emit({});
        }
      }
      else
        this.value = this.value.filter(v => v.toString().trim() !== value.toString().trim());
    }
  }
  getRawValues() {
    var result;
    if (this.values == null) {
      result = [];
    }
    else if (typeof this.values === 'string') {
      if (this.values == '')
        result = [];
      else
        result = JSON.parse(this.values);
    }
    else {
      result = [...this.values];
    }
    return result;
  }
  getFilteredValues() {
    if (!this.open)
      return [];
    // The suggest control should not consider categories
    return this.getFilteredValuesWhenClosed();
  }
  getFilteredValuesWhenClosed() {
    var result = this.getAtomicValues();
    if (this.searchvalue != '')
      result = this.getFilteredValues_impl(result);
    return result;
  }
  getFilteredValues_impl(origin) {
    var result = [];
    if (origin != undefined) {
      for (let cv of origin) {
        if (cv.description.toLocaleLowerCase().indexOf(this.searchvalue.toLocaleLowerCase()) != -1) {
          result = result.concat(cv);
        }
        else {
          // Check if child items must be added
          var filteredChildren = this.getFilteredValues_impl(cv.items);
          if (filteredChildren.length > 0) {
            var cv2 = Object.assign({}, cv);
            cv2.items = filteredChildren;
            result = result.concat(cv2);
          }
        }
      }
    }
    return result;
  }
  onIncludeNewRecordClick() {
    this.open = false;
    this.newRecordClickedEvent.emit(null);
  }
  getAtomicValues() {
    const atomicValues = utils.ControlInfoValue.getAtomicValues_impl(this.getRawValues());
    return this.removeDuplicates(atomicValues);
  }
  removeDuplicates(atomicValues) {
    return atomicValues.filter((value, index, self) => index === self.findIndex(t => t.value === value.value));
  }
  getSuggestPopoverContent() {
    const rawValues = this.getRawValues();
    var containsDetails = utils.ControlInfoValue.containsDetails(rawValues);
    var containsIcons = utils.ControlInfoValue.containsIcons(rawValues);
    var containsTrailingText = utils.ControlInfoValue.containsTrailingText(rawValues);
    if (this.clientSideFiltering == K2btEnhancedsuggest.FILTERING_ENABLED) {
      const filteredValues = this.getFilteredValues().slice(0, this.suggestmaxitems);
      if (filteredValues.length > 0)
        return filteredValues.map(item => this.getItemContent(item, containsDetails, containsIcons, containsTrailingText));
      else if (this.waitingInformationFromServer)
        return index.h("div", { class: "K2BT_LoadingSpinner" });
      else
        return index.h("div", { class: "K2BTEnhancedComboNoItemsFound" }, this.noresultsfoundtext);
    }
    else {
      const values = this.getAtomicValues().slice(0, this.suggestmaxitems);
      if (this.waitingInformationFromServer)
        return index.h("div", { class: "K2BT_LoadingSpinner" });
      else if (values.length > 0)
        return values.map(item => this.getItemContent(item, containsDetails, containsIcons, containsTrailingText));
      else
        return index.h("div", { class: "K2BTEnhancedComboNoItemsFound" }, this.noresultsfoundtext);
    }
  }
  onImageError(e) {
    e.target.classList.add('K2BTEnhancedComboIconInvisible');
  }
  getItemContent(item, containsDetails, containsIcons, containsTrailingText) {
    var _a;
    if (((_a = item.items) === null || _a === void 0 ? void 0 : _a.length) > 0) {
      // Item is a category
      return this.getCategoryContent(item, containsDetails, containsIcons, containsTrailingText);
    }
    else {
      return this.getAtomicItemContent(item, containsIcons, containsTrailingText, containsDetails);
    }
  }
  getAtomicItemContent(item, containsIcons, containsTrailingText, containsDetails) {
    var itemClass = this.getItemClass(item);
    return (index.h("div", { class: itemClass, ref: c => {
        if (this.itemIsSelected(item) || this.activeElementValue === item.value)
          this.selectedElement = c;
      }, onClick: () => {
        this.setValue(item.value);
      } }, this.addCheckboxIfNecessary(item), this.addIconIfNecessary(containsIcons, item), this.addMainItemContent(item, containsTrailingText, containsDetails)));
  }
  addMainItemContent(item, containsTrailingText, containsDetails) {
    return (index.h("div", { class: "K2BTEnhancedComboItem_TextColumn" }, index.h("div", { class: "K2BTEnhancedComboItem_TextContainer" }, index.h("span", { class: "K2BTEnhancedComboDescription" }, this.getHighlightedText(item.description)), containsTrailingText ? index.h("span", { class: "K2BTEnhancedComboTrailingText" }, this.getHighlightedText(item.trailingText)) : ''), index.h("div", { class: "K2BTEnhancedComboItem_TextContainer" }, containsDetails ? index.h("span", { class: "K2BTEnhancedComboSubtitle" }, this.getHighlightedText(item.detail)) : '')));
  }
  addIconIfNecessary(containsIcons, item) {
    return containsIcons ? (index.h("div", { class: "K2BTEnhancedComboIconContainer" }, index.h("img", { class: "K2BTEnhancedComboIcon", src: item.imageUrl, onError: e => this.onImageError(e) }))) : ('');
  }
  addCheckboxIfNecessary(item) {
    return this.isCollection() ? (index.h("div", { class: "K2BT_EnhancedComboCheckbox" }, index.h("input", { type: "checkbox", checked: this.itemIsSelected(item), tabIndex: -1, disabled: this.selectionIsFull() && !this.itemIsSelected(item) }), index.h("label", { htmlFor: "", "data-gx-sr-only": "" }, "\u00A0"))) : ('');
  }
  getItemClass(item) {
    var itemClass = 'K2BTEnhancedComboItem';
    if (this.itemIsSelected(item))
      itemClass += ' K2BTEnhancedComboSelected';
    else if (this.selectionIsFull())
      itemClass += ' K2BTEnhancedComboDisabled';
    if (this.activeElementValue === item.value)
      itemClass += ' K2BTEnhancedComboActive';
    return itemClass;
  }
  getCategoryContent(item, containsDetails, containsIcons, containsTrailingText) {
    return (index.h("div", { class: "K2BTEnhancedComboCategory" }, index.h("span", { class: "K2BTEnhancedComboCategoryName" }, item.description), index.h("div", { class: "K2BTEnchancedComboCategoryContents" }, item.items.map(i => this.getItemContent(i, containsDetails, containsIcons, containsTrailingText)))));
  }
  getHighlightedText(originalText) {
    var position = originalText.toLowerCase().indexOf(this.searchvalue.toLowerCase());
    if (this.clientSideFiltering == K2btEnhancedsuggest.FILTERING_DISABLED || this.searchvalue == undefined || this.searchvalue == '' || position == -1) {
      return index.h("span", null, originalText);
    }
    else {
      return (index.h("span", null, originalText.substring(0, position), index.h("span", { class: "K2BTEnhancedComboSearchHighlight" }, originalText.substring(position, position + this.searchvalue.length)), this.getHighlightedText(originalText.substring(position + this.searchvalue.length))));
    }
  }
  onValuesChanged(_newValue, _oldValue) {
    this.waitingInformationFromServer = false;
  }
  changeSearchValue(value) {
    this.searchvalue = value;
    this.open = true;
    this.waitingInformationFromServer = true;
    if (!this.isCollection()) {
      var valueSelected = this.getAtomicValues()
        .map(v => v.value)
        .indexOf(this.value[0]) != -1;
      this.value = [];
      if (valueSelected)
        this.emitChangedEvent();
    }
    if (this.seekSuggestValuesDebouncer) {
      clearTimeout(this.seekSuggestValuesDebouncer);
      this.seekSuggestValuesDebouncer = null;
    }
    this.seekSuggestValuesDebouncer = setTimeout((() => {
      this.seekSuggestValuesDebouncer = null;
      this.inputValueChangedEvent.emit(null);
    }).bind(this), 200);
  }
  getValueDescription() {
    if (this.value.length === 1) {
      var values = this.getAtomicValues();
      var v = values.find(val => val.value == this.value[0]);
      if (v != undefined) {
        return v.description;
      }
      return this.value[0];
    }
    return '';
  }
  getReadonlyValue(headerValues) {
    if (headerValues.length == 0)
      return this.emptyitemtext;
    else {
      return headerValues.map(v => v.description).join(', ');
    }
  }
  componentWillRender() {
    if (this.value == null || this.value == undefined || this.value.length === 0) {
      const valuesMatchingDescription = this.getAtomicValues().filter(item => { var _a; return item.description == ((_a = this.searchfield) === null || _a === void 0 ? void 0 : _a.value); });
      if (valuesMatchingDescription.length > 0) {
        this.setValueWithoutClosing(valuesMatchingDescription[0].value);
      }
    }
  }
  getHeaderTagsContent(vals) {
    var containsIcons = utils.ControlInfoValue.containsIcons(this.getAtomicValues());
    if (this.isCollection())
      return vals.map(v => {
        return (index.h("div", { class: "K2BT_EnhancedComboHeaderTag" }, this.showiconsintags && containsIcons && v.imageUrl !== '' ? index.h("img", { class: "K2BT_EnhancedComboTagIcon", src: v.imageUrl }) : '', index.h("span", { class: "K2BT_EnhancedComboHeaderTagDescription" }, v.description), index.h("span", { class: "K2BT_EnhancedComboHeaderTagDelete", onClick: ev => {
            ev.cancelBubble = true;
            this.setValueWithoutClosing(v.value);
            this.emitChangedEvent();
          } })));
      });
  }
  render() {
    var itemsSectionStyle = {};
    if (this.inputSize > 0) {
      //@ts-ignore
      itemsSectionStyle.width = this.inputSize + 'ch !important;';
      //@ts-ignore
      itemsSectionStyle.minWidth = 'initial';
    }
    var atomicValues = this.getAtomicValues();
    const headerValues = this.value.map(sv => atomicValues.filter(v => sv.toString().trim() === v.value.trim())[0]).filter(f => f);
    this.selectedElement = null;
    return (index.h("div", null, index.h("p", { class: "form-control-static", style: this.enabled ? { display: 'none' } : {} }, index.h("span", { class: !this.enabled ? this.readonlyclass : this.readonlyclass + ' gx-invisible', "data-gx-readonly": "" }, this.getReadonlyValue(headerValues))), index.h("div", { class: "K2BTEnhancedSuggest", ref: node => (this.container = node), style: !this.enabled ? { display: 'none' } : {} }, index.h("div", { class: "K2BTEnhancedSuggestTags" }, this.getHeaderTagsContent(headerValues)), index.h("input", { type: "text", class: "form-control Attribute_Trn K2BTEnhancedSuggestInput", value: this.searchvalue, size: this.inputSize, onInput: event => {
        event.preventDefault();
        this.changeSearchValue(event.target.value);
        return false;
      }, placeholder: this.placeholder, onClick: () => {
        this.open = true;
        this.activeElementValue = null;
      }, onFocus: () => {
        this.open = true;
        this.focusEvent.emit();
      }, ref: control => (this.searchfield = control) }), index.h("div", { class: this.open ? 'K2BTEnhancedComboContentsOpen' : 'K2BTEnhancedComboContentsClosed', style: itemsSectionStyle }, index.h("div", { class: "K2BTEnhancedComboItems" }, this.getSuggestPopoverContent()), this.enableadditem ? (index.h("span", { class: "K2BTEnhancedComboNewAction", onClick: () => this.onIncludeNewRecordClick() }, this.additemcaption)) : ('')))));
  }
  static get watchers() { return {
    "values": ["onValuesChanged"]
  }; }
};
K2btEnhancedsuggest.ERROR_SELECTION_FULL = 'SELECTION_FULL';
K2btEnhancedsuggest.FILTERING_ENABLED = 'Enabled';
K2btEnhancedsuggest.FILTERING_DISABLED = 'Disabled';
K2btEnhancedsuggest.style = k2btEnhancedsuggestCss;

const K2btSplitDatepicker = class {
  constructor(hostRef) {
    index.registerInstance(this, hostRef);
    this.inputEvent = index.createEvent(this, "dateinput", 7);
    this.changeEvent = index.createEvent(this, "datechange", 7);
    this.value = null;
    this.readonlyclass = '';
    this.enabled = true;
    this.validationerrorcode = K2btSplitDatepicker.VALIDATION_ERROR_NOERROR;
    this.yearControl = null;
    this.monthControl = null;
    this.dayControl = null;
    this.minuteControl = null;
    this.hourControl = null;
  }
  connectedCallback() {
    if (this.value) {
      this.selectedYear = this.value.getFullYear();
      this.selectedMonth = this.value.getMonth() + 1;
      this.selectedDay = this.value.getDate();
      this.selectedHour = this.value.getHours();
      this.selectedMinute = this.value.getMinutes();
    }
    else {
      this.selectedYear = 0;
      this.selectedMonth = 0;
      this.selectedDay = 0;
      this.selectedHour = -1;
      this.selectedMinute = -1;
      this.validationerrorcode = K2btSplitDatepicker.VALIDATION_ERROR_EMPTYYEAR;
    }
    this.validateDate();
  }
  render() {
    var readonlyClassString = this.readonlyclass;
    return (index.h(index.Host, null, index.h("p", { class: "form-control-static", style: this.enabled ? { display: 'none' } : {} }, index.h("span", { class: readonlyClassString, "data-gx-readonly": "" }, this.getReadonlyContents())), index.h("div", { style: !this.enabled ? { display: 'none' } : {} }, this.renderDatepickerContents())));
  }
  getReadonlyContents() {
    switch (this.fieldorder) {
      case K2btSplitDatepicker.ORDER_DMY:
        return `${this.normalizeToAmountOfDigits(this.selectedDay, 2)}/${this.getSelectedMonthString()}/${this.normalizeToAmountOfDigits(this.selectedYear, 4)} ${this.normalizeToAmountOfDigits(this.selectedHour, 2)}:${this.normalizeToAmountOfDigits(this.selectedMinute, 2)}`;
      case K2btSplitDatepicker.ORDER_YMD:
        return `${this.normalizeToAmountOfDigits(this.selectedYear, 4)}/${this.getSelectedMonthString()}/${this.normalizeToAmountOfDigits(this.selectedDay, 2)} ${this.normalizeToAmountOfDigits(this.selectedHour, 2)}:${this.normalizeToAmountOfDigits(this.selectedMinute, 2)}`;
      case K2btSplitDatepicker.ORDER_MDY:
        return `${this.getSelectedMonthString()}/${this.normalizeToAmountOfDigits(this.selectedDay, 2)}/${this.normalizeToAmountOfDigits(this.selectedYear, 4)} ${this.normalizeToAmountOfDigits(this.selectedHour, 2)}:${this.normalizeToAmountOfDigits(this.selectedMinute, 2)}`;
    }
  }
  getSelectedMonthString() {
    var month = this.selectedMonth;
    if (month === 0)
      return this.normalizeToAmountOfDigits(0, 2);
    switch (this.showmonthas) {
      case K2btSplitDatepicker.SHOWMONTHAS_NUMBER:
        return this.normalizeToAmountOfDigits(month, 2);
      case K2btSplitDatepicker.SHOWMONTHAS_NAME:
        //@ts-ignore
        return k2btools.getMonthName(month - 1);
      case K2btSplitDatepicker.SHOWMONTHAS_SHORTNAME:
        //@ts-ignore
        return k2btools.getMonthShortName(month - 1);
    }
  }
  normalizeToAmountOfDigits(value, digits) {
    return '0'.repeat(digits - value.toString().length) + value.toString();
  }
  renderDatepickerContents() {
    switch (this.fieldorder) {
      case K2btSplitDatepicker.ORDER_DMY:
        return (index.h("div", { class: "K2BT_SplitDatepicker" }, this.renderDayField(), this.renderMonthField(), this.renderYearField(), this.renderTimeFields()));
      case K2btSplitDatepicker.ORDER_YMD:
        return (index.h("div", { class: "K2BT_SplitDatepicker" }, this.renderYearField(), this.renderMonthField(), this.renderDayField(), this.renderTimeFields()));
      case K2btSplitDatepicker.ORDER_MDY:
        return (index.h("div", { class: "K2BT_SplitDatepicker" }, this.renderMonthField(), this.renderDayField(), this.renderYearField(), this.renderTimeFields()));
    }
  }
  renderTimeFields() {
    return (index.h("div", { class: "K2BT_SplitDatepickerTime" }, this.renderHourField(), this.renderMinuteField()));
  }
  renderYearField() {
    if (this.fieldcontroltype == K2btSplitDatepicker.FIELDCONTROLTYPE_COMBO) {
      return this.renderYearFieldAsCombo();
    }
    else {
      if (this.minimumdate) {
        return this.renderYearFieldAsSuggest();
      }
      else {
        return this.renderYearFieldAsInputWithNoSuggest();
      }
    }
  }
  renderYearFieldAsInputWithNoSuggest() {
    return (index.h("input", { type: "text", class: "form-control Attribute_Trn", size: Math.max(4, this.yearinvitemessage.length), placeholder: this.yearinvitemessage, ref: c => (this.yearControl = c), value: this.selectedYear != 0 ? this.selectedYear.toString() : '', onChange: () => {
        if (this.yearControl.value)
          this.selectedYear = parseInt(this.yearControl.value);
        else
          this.selectedYear = 0;
        if (isNaN(this.selectedYear))
          this.selectedYear = 0;
        this.validateDate();
      } }));
  }
  renderYearFieldAsSuggest() {
    const AMOUNT_OF_SUGGEST_ITEMS = 15;
    return (index.h("k2bt-enhancedsuggest", { inputSize: Math.max(4, this.yearinvitemessage.length), onSuggestValueChanged: this.processYearChange.bind(this), enableadditem: false, placeholder: this.yearinvitemessage, noresultsfoundtext: this.yearnotfoundmessage, value: this.selectedYear != 0 ? [this.selectedYear.toString()] : [], values: this.getCandidateYears(AMOUNT_OF_SUGGEST_ITEMS), maxSelectionSize: 1, suggestmaxitems: AMOUNT_OF_SUGGEST_ITEMS, ref: c => (this.yearControl = c), clientSideFiltering: "Disabled", onInputValueChanged: () => {
        this.yearControl.values = this.getCandidateYears(AMOUNT_OF_SUGGEST_ITEMS);
      } }));
  }
  renderYearFieldAsCombo() {
    var values = Array.from(Array(this.maximumdate.getFullYear() - this.minimumdate.getFullYear() + 1).keys()).map(i => {
      var year = i + this.minimumdate.getFullYear();
      return { value: year.toString(), description: this.normalizeToAmountOfDigits(year, 4) };
    });
    return (index.h("k2bt-enhancedcombo", { optionswidth: Math.max(4, this.yearinvitemessage.length) + 'ch !important', showemptyiteminlist: false, onChange: this.processYearChange.bind(this), includesearch: false, showselectionastags: false, enableadditem: false, includeemptyitem: true, emptyitemtext: this.yearinvitemessage, headermaxvisibleitems: 1, values: values, value: this.selectedYear != 0 ? [this.selectedYear.toString()] : [], maxSelectionSize: 1, ref: c => (this.yearControl = c) }));
  }
  processYearChange() {
    var _a, _b;
    if (((_b = (_a = this.yearControl.value) === null || _a === void 0 ? void 0 : _a.length) !== null && _b !== void 0 ? _b : 0) > 0)
      this.selectedYear = parseInt(this.yearControl.value[0]);
    else
      this.selectedYear = 0;
    if (isNaN(this.selectedYear) ||
      (this.maximumdate && this.selectedYear > this.maximumdate.getFullYear()) ||
      (this.minimumdate && this.selectedYear < this.minimumdate.getFullYear()))
      this.selectedYear = 0;
    this.validateDate();
  }
  getCandidateYears(max_candidates) {
    var _a, _b;
    var prefix = (_b = (_a = this.yearControl) === null || _a === void 0 ? void 0 : _a.searchvalue) !== null && _b !== void 0 ? _b : '';
    var start = this.getStartYearForSuggestions(prefix);
    max_candidates = Math.min(max_candidates, Math.pow(10, 4 - prefix.length));
    if (this.minimumdate || prefix.length >= 2)
      return Array.from(Array(max_candidates).keys())
        .map(i => i + start)
        .filter(year => this.maximumdate == null || year <= this.maximumdate.getFullYear())
        .map(y => {
        return { value: y.toString(), description: y.toString() };
      });
    else
      return [];
  }
  getStartYearForSuggestions(prefix) {
    var start = 0;
    if (prefix !== '') {
      const missingDigits = prefix.length <= 4 ? 4 - prefix.length : 0;
      start = parseInt(prefix) * Math.pow(10, missingDigits);
    }
    if (this.minimumdate != null)
      start = Math.max(start, this.minimumdate.getFullYear(), this.selectedYear);
    return start;
  }
  renderMonthField() {
    var values = this.getMonthValues();
    if (this.fieldcontroltype == K2btSplitDatepicker.FIELDCONTROLTYPE_COMBO) {
      return this.renderMonthAsCombo(values);
    }
    else {
      return this.renderMonthAsSuggest(values);
    }
  }
  renderMonthAsSuggest(values) {
    return (index.h("k2bt-enhancedsuggest", {
      //@ts-ignore
      inputSize: Math.max(Math.max(...values.map(v => v.description.length)), this.monthinvitemessage.length), onSuggestValueChanged: this.processMonthChange.bind(this), enableadditem: false, placeholder: this.monthinvitemessage, noresultsfoundtext: this.monthnotfoundmessage, value: this.selectedMonth != 0 ? [this.selectedMonth.toString()] : [], values: values, suggestmaxitems: 12, maxSelectionSize: 1, ref: c => (this.monthControl = c), onInputValueChanged: () => (this.monthControl.values = this.getMonthValues())
    }));
  }
  renderMonthAsCombo(values) {
    return (index.h("k2bt-enhancedcombo", { optionswidth: Math.max(Math.max(...values.map(v => v.description.length)), this.monthinvitemessage.length) + 'ch !important', showemptyiteminlist: false, onChange: this.processMonthChange.bind(this), includesearch: false, showselectionastags: false, enableadditem: false, includeemptyitem: true, emptyitemtext: this.monthinvitemessage, headermaxvisibleitems: 1, values: values, value: this.selectedMonth != 0 ? [this.selectedMonth.toString()] : [], maxSelectionSize: 1, ref: c => (this.monthControl = c) }));
  }
  processMonthChange() {
    var _a, _b;
    if (((_b = (_a = this.monthControl.value) === null || _a === void 0 ? void 0 : _a.length) !== null && _b !== void 0 ? _b : 0) > 0)
      this.selectedMonth = parseInt(this.monthControl.value[0]);
    else
      this.selectedMonth = 0;
    if (isNaN(this.selectedMonth) || this.selectedMonth > 12 || this.selectedMonth < 1)
      this.selectedMonth = 0;
    this.validateDate();
  }
  getMonthValues() {
    switch (this.showmonthas) {
      case K2btSplitDatepicker.SHOWMONTHAS_NUMBER:
        return Array.from(Array(12).keys()).map(i => {
          var month = i + 1;
          return { value: month.toString(), description: this.normalizeToAmountOfDigits(month, 2) };
        });
      case K2btSplitDatepicker.SHOWMONTHAS_NAME:
        return Array.from(Array(12).keys()).map(i => {
          var month = i + 1;
          //@ts-ignore
          return { value: month.toString(), description: k2btools.getMonthName(month - 1) };
        });
      case K2btSplitDatepicker.SHOWMONTHAS_SHORTNAME:
        return Array.from(Array(12).keys()).map(i => {
          var month = i + 1;
          //@ts-ignore
          return { value: month.toString(), description: k2btools.getMonthShortName(month - 1) };
        });
    }
  }
  renderDayField() {
    var values = Array.from(Array(31).keys()).map(i => {
      var day = i + 1;
      return { value: day.toString(), description: this.normalizeToAmountOfDigits(day, 2) };
    });
    if (this.fieldcontroltype == K2btSplitDatepicker.FIELDCONTROLTYPE_COMBO) {
      return this.renderDayFieldAsCombo(values);
    }
    else {
      return this.renderDayFieldAsSuggest(values);
    }
  }
  renderDayFieldAsSuggest(values) {
    return (index.h("k2bt-enhancedsuggest", { inputSize: Math.max(2, this.dayinvitemessage.length), onSuggestValueChanged: this.processDayChange.bind(this), enableadditem: false, placeholder: this.dayinvitemessage, noresultsfoundtext: this.daynotfoundmessage, value: this.selectedDay != 0 ? [this.selectedDay.toString()] : [], values: values, maxSelectionSize: 1, suggestmaxitems: 31, ref: c => (this.dayControl = c), onInputValueChanged: () => (this.dayControl.values = [...values]) }));
  }
  renderDayFieldAsCombo(values) {
    return (index.h("k2bt-enhancedcombo", { optionswidth: Math.max(2, this.dayinvitemessage.length) + 'ch !important', showemptyiteminlist: false, onChange: this.processDayChange.bind(this), includesearch: false, showselectionastags: false, enableadditem: false, includeemptyitem: true, emptyitemtext: this.dayinvitemessage, headermaxvisibleitems: 1, values: values, value: this.selectedDay != 0 ? [this.selectedDay.toString()] : [], maxSelectionSize: 1, ref: c => (this.dayControl = c) }));
  }
  processDayChange() {
    var _a, _b;
    if (((_b = (_a = this.dayControl.value) === null || _a === void 0 ? void 0 : _a.length) !== null && _b !== void 0 ? _b : 0) > 0)
      this.selectedDay = parseInt(this.dayControl.value[0]);
    else
      this.selectedDay = 0;
    if (isNaN(this.selectedDay) || this.selectedDay > 31 || this.selectedDay < 1)
      this.selectedDay = 0;
    this.validateDate();
  }
  getMaxDayForSelectedMonth() {
    var year = this.selectedYear;
    var month = this.selectedMonth;
    // This is the first date of next month (as month parameter is 0 based)
    const nextMonth = new Date(year, month, 1);
    nextMonth.setDate(nextMonth.getDate() - 1);
    return nextMonth.getDate();
  }
  renderHourField() {
    if (!this.showtimepart)
      return null;
    var values = this.getHourFieldValues();
    if (this.fieldcontroltype == K2btSplitDatepicker.FIELDCONTROLTYPE_COMBO) {
      return this.renderHourFieldAsCombo(values);
    }
    else {
      return this.renderHourFieldAsSuggest(values);
    }
  }
  getHourFieldValues() {
    return Array.from(Array(this.endhour + 1 - this.starthour).keys()).map(i => {
      var hour = i + this.starthour; // +1 to avoid "empty" values
      if (this.hourformat == K2btSplitDatepicker.HOURFORMAT_24H)
        return { value: (hour + 1).toString(), description: this.normalizeToAmountOfDigits(hour, 2) };
      else {
        var ampmHour = hour;
        if (hour === 0)
          ampmHour = 12;
        if (hour > 12)
          ampmHour = hour - 12;
        return { value: (hour + 1).toString(), description: ampmHour.toString() + ' ' + (hour >= 12 ? 'PM' : 'AM') };
      }
    });
  }
  renderHourFieldAsSuggest(values) {
    return (index.h("k2bt-enhancedsuggest", {
      //@ts-ignore
      inputSize: Math.max(Math.max(...values.map(v => v.description.length)), this.hourinvitemessage.length), onSuggestValueChanged: this.processHourChange.bind(this), enableadditem: false, placeholder: this.hourinvitemessage, noresultsfoundtext: this.hournotfoundmessage, values: values, suggestmaxitems: 24, value: this.selectedHour != -1 ? [(this.selectedHour + 1).toString()] : [], maxSelectionSize: 1, ref: c => (this.hourControl = c), onInputValueChanged: () => (this.hourControl.values = [...values])
    }));
  }
  renderHourFieldAsCombo(values) {
    return (index.h("k2bt-enhancedcombo", { optionswidth: Math.max(Math.max(...values.map(v => v.description.length)), this.hourinvitemessage.length) + 'ch !important', showemptyiteminlist: false, onChange: this.processHourChange.bind(this), includesearch: false, showselectionastags: false, enableadditem: false, includeemptyitem: true, emptyitemvalue: "-1", emptyitemtext: this.hourinvitemessage, headermaxvisibleitems: 1, values: values, value: this.selectedHour != -1 ? [(this.selectedHour + 1).toString()] : [], maxSelectionSize: 1, ref: c => (this.hourControl = c) }));
  }
  processHourChange() {
    var _a, _b;
    // Decrease 1 because of values being 1-based and not 0-based
    if (((_b = (_a = this.hourControl.value) === null || _a === void 0 ? void 0 : _a.length) !== null && _b !== void 0 ? _b : 0) > 0)
      this.selectedHour = parseInt(this.hourControl.value[0]) - 1;
    else
      this.selectedYear = 0;
    this.validateDate();
  }
  renderMinuteField() {
    if (!this.showtimepart)
      return null;
    var values = [];
    for (var m = 0; m < 60; m += this.minutestep) {
      // starting in 1 to avoid "empty" values
      values.push({ value: (m + 1).toString(), description: this.normalizeToAmountOfDigits(m, 2) });
    }
    if (this.fieldcontroltype == K2btSplitDatepicker.FIELDCONTROLTYPE_COMBO) {
      return this.renderMinuteFieldAsCombo(values);
    }
    else {
      return this.renderMinuteFieldAsSuggest(values);
    }
  }
  renderMinuteFieldAsSuggest(values) {
    return (index.h("k2bt-enhancedsuggest", {
      //@ts-ignore
      inputSize: Math.max(Math.max(...values.map(v => v.description.length)), this.minuteinvitemessage.length), onSuggestValueChanged: this.processMinuteChange.bind(this), suggestmaxitems: 60, enableadditem: false, placeholder: this.minuteinvitemessage, noresultsfoundtext: this.minutenotfoundmessage, values: values, value: this.selectedMinute != -1 ? [(this.selectedMinute + 1).toString()] : [], maxSelectionSize: 1, ref: c => (this.minuteControl = c), onInputValueChanged: () => (this.minuteControl.values = [...values])
    }));
  }
  processMinuteChange() {
    var _a, _b;
    // Decrease 1 because of values being 1-based and not 0-based
    if (((_b = (_a = this.minuteControl.value) === null || _a === void 0 ? void 0 : _a.length) !== null && _b !== void 0 ? _b : 0) > 0)
      this.selectedMinute = parseInt(this.minuteControl.value[0]) - 1;
    else
      this.selectedMinute = 0;
    this.validateDate();
  }
  renderMinuteFieldAsCombo(values) {
    return (index.h("k2bt-enhancedcombo", { optionswidth: Math.max(Math.max(...values.map(v => v.description.length)), this.minuteinvitemessage.length) + 'ch !important', showemptyiteminlist: false, onChange: this.processMinuteChange.bind(this), includesearch: false, showselectionastags: false, enableadditem: false, includeemptyitem: true, emptyitemvalue: "-1", emptyitemtext: this.minuteinvitemessage, headermaxvisibleitems: 1, values: values, value: this.selectedMinute != -1 ? [(this.selectedMinute + 1).toString()] : [], maxSelectionSize: 1, ref: c => (this.minuteControl = c) }));
  }
  componentDidRender() {
    var _a, _b, _c, _d, _e;
    if (this.fieldcontroltype == K2btSplitDatepicker.FIELDCONTROLTYPE_SUGGEST) {
      //@ts-ignore
      if ((_a = this.yearControl) === null || _a === void 0 ? void 0 : _a.updateDescription)
        this.yearControl.updateDescription();
      //@ts-ignore
      if ((_b = this.monthControl) === null || _b === void 0 ? void 0 : _b.updateDescription)
        this.monthControl.updateDescription();
      //@ts-ignore
      if ((_c = this.dayControl) === null || _c === void 0 ? void 0 : _c.updateDescription)
        this.dayControl.updateDescription();
      //@ts-ignore
      if ((_d = this.hourControl) === null || _d === void 0 ? void 0 : _d.updateDescription)
        this.hourControl.updateDescription();
      //@ts-ignore
      if ((_e = this.minuteControl) === null || _e === void 0 ? void 0 : _e.updateDescription)
        this.minuteControl.updateDescription();
    }
  }
  validateDate() {
    this.validationerrorcode = K2btSplitDatepicker.VALIDATION_ERROR_NOERROR;
    // Validate not empty
    if (this.validationerrorcode === K2btSplitDatepicker.VALIDATION_ERROR_NOERROR && this.selectedDay == 0)
      this.validationerrorcode = K2btSplitDatepicker.VALIDATION_ERROR_EMPTYDAY;
    if (this.validationerrorcode === K2btSplitDatepicker.VALIDATION_ERROR_NOERROR && this.selectedMonth == 0)
      this.validationerrorcode = K2btSplitDatepicker.VALIDATION_ERROR_EMPTYMONTH;
    if (this.validationerrorcode === K2btSplitDatepicker.VALIDATION_ERROR_NOERROR && this.selectedYear == 0)
      this.validationerrorcode = K2btSplitDatepicker.VALIDATION_ERROR_EMPTYYEAR;
    if (this.showtimepart) {
      if (this.validationerrorcode === K2btSplitDatepicker.VALIDATION_ERROR_NOERROR && this.selectedHour == -1)
        this.validationerrorcode = K2btSplitDatepicker.VALIDATION_ERROR_EMPTYHOUR;
      if (this.validationerrorcode === K2btSplitDatepicker.VALIDATION_ERROR_NOERROR && this.selectedMinute == -1)
        this.validationerrorcode = K2btSplitDatepicker.VALIDATION_ERROR_EMPTYMINUTE;
    }
    // Validate month boundary
    var day = this.selectedDay;
    const maxDayForMonth = this.getMaxDayForSelectedMonth();
    if (this.validationerrorcode === K2btSplitDatepicker.VALIDATION_ERROR_NOERROR && day > maxDayForMonth)
      this.validationerrorcode = K2btSplitDatepicker.VALIDATION_ERROR_INVALIDDAYFORMONTH;
    const candidateDate = this.showtimepart
      ? new Date(this.selectedYear, this.selectedMonth - 1, day, this.selectedHour, this.selectedMinute)
      : new Date(this.selectedYear, this.selectedMonth - 1, day);
    // Validate accepted date ranges
    if (this.validationerrorcode === K2btSplitDatepicker.VALIDATION_ERROR_NOERROR && this.minimumdate && candidateDate < this.minimumdate)
      this.validationerrorcode = K2btSplitDatepicker.VALIDATION_ERROR_DATETOOLOW;
    if (this.validationerrorcode === K2btSplitDatepicker.VALIDATION_ERROR_NOERROR && this.maximumdate && candidateDate > this.maximumdate)
      this.validationerrorcode = K2btSplitDatepicker.VALIDATION_ERROR_DATETOOHIGH;
    if (this.validationerrorcode === K2btSplitDatepicker.VALIDATION_ERROR_NOERROR)
      this.value = candidateDate;
    else
      this.value = null;
    this.inputEvent.emit({});
    this.changeEvent.emit({});
  }
};
K2btSplitDatepicker.ORDER_DMY = 'DMY';
K2btSplitDatepicker.ORDER_YMD = 'YMD';
K2btSplitDatepicker.ORDER_MDY = 'MDY';
K2btSplitDatepicker.SHOWMONTHAS_NAME = 'Name';
K2btSplitDatepicker.SHOWMONTHAS_SHORTNAME = 'ShortName';
K2btSplitDatepicker.SHOWMONTHAS_NUMBER = 'Number';
K2btSplitDatepicker.HOURFORMAT_AMPM = 'AM/PM';
K2btSplitDatepicker.HOURFORMAT_24H = '24H';
K2btSplitDatepicker.FIELDCONTROLTYPE_COMBO = 'ComboBox';
K2btSplitDatepicker.FIELDCONTROLTYPE_SUGGEST = 'Suggest';
K2btSplitDatepicker.VALIDATION_ERROR_NOERROR = '0';
K2btSplitDatepicker.VALIDATION_ERROR_EMPTYDAY = '1';
K2btSplitDatepicker.VALIDATION_ERROR_EMPTYMONTH = '2';
K2btSplitDatepicker.VALIDATION_ERROR_EMPTYYEAR = '3';
K2btSplitDatepicker.VALIDATION_ERROR_INVALIDDAYFORMONTH = '4';
K2btSplitDatepicker.VALIDATION_ERROR_DATETOOLOW = '5';
K2btSplitDatepicker.VALIDATION_ERROR_DATETOOHIGH = '6';
K2btSplitDatepicker.VALIDATION_ERROR_EMPTYHOUR = '7';
K2btSplitDatepicker.VALIDATION_ERROR_EMPTYMINUTE = '8';

exports.k2bt_enhancedcombo = K2btEnhancedcombo;
exports.k2bt_enhancedsuggest = K2btEnhancedsuggest;
exports.k2bt_split_datepicker = K2btSplitDatepicker;
